Bug 1269539 - Review Request: mozjs38 - JavaScript interpreter and libraries
Review Request: mozjs38 - JavaScript interpreter and libraries
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Paulo Andrade
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-07 10:11 EDT by Marek Skalický
Modified: 2015-12-05 20:23 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-05 20:23:19 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
paulo.cesar.pereira.de.andrade: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Marek Skalický 2015-10-07 10:11:44 EDT
Spec URL: https://mskalick.fedorapeople.org/mozjs38/mozjs38.spec
SRPM URL: https://mskalick.fedorapeople.org/mozjs38/mozjs38-38.2.1-1.fc22.src.rpm
Description: JavaScript is the Netscape-developed object scripting language used in millions of web pages and server applications worldwide. Netscape's JavaScript is a super set of the ECMA-262 Edition 3 (ECMAScript) standard scripting language, with only mild differences from the published standard.
Fedora Account System Username: mskalick
Comment 1 Paulo Andrade 2015-10-08 22:28:50 EDT
I will review it, as I recently packaged mozjs31, and I
may need mozjs38 as dependency for my packages soon.
Comment 2 Paulo Andrade 2015-10-08 23:57:19 EDT
  Marek,

  The package looks quite good. I made some considerations
below. Most important is the License issue, due tonew files
under ASL 2.0.

  Looking at build log, most warnings appear ok, but this
one might have issues:

In file included from /builddir/build/BUILD/mozjs-38.0.0/js/src/js/src/Unified_cpp_js_src2.cpp:65:0:
/builddir/build/BUILD/mozjs-38.0.0/js/src/irregexp/RegExpEngine.cpp: In member function 'virtual bool js::irregexp::TextNode::FillInBMInfo(int, int, js::irregexp::BoyerMooreLookahead*, bool)':
/builddir/build/BUILD/mozjs-38.0.0/js/src/irregexp/RegExpEngine.cpp:4605:48: warning: array subscript is above array bounds [-Warray-bounds]
                         bm->Set(offset, chars[j]);

looking at the code it appears to be a false positive, likely
because g++ did not understand that it should always return
a value that is in bounds. But I may be mistaken, please
comment.

---8<---
mozjs38.src:18: W: mixed-use-of-spaces-and-tabs (spaces: line 18, tab: line 1)

Looks like you added a missing build requires from mozjs31
spec, but did not match spaces vs tabs :)

---8<---
In js.pc I see:
Version: 38.3.0esrpre

Looks like there is some confusion. But this is minor,
just a comment. Should be expected from a .rc0.

---8<---
I believe is is not strictly an update do mozjs31, so you may
modify the changelog to not say so. It should only have conflicts
with mozjs31-devel and mozjs38-devel, otherwise, runtime will
not conflict.

---8<---
Please remove the bundled mozjs-38.0.0/modules/zlib/
directory before starting build (mozjs31 does not have
a modules subdir). It should not use it due to --with-system-zlib,
but just to be sure.

---8<---
There are some new files under apache license, so, it should
be required to add "ASL 2.0" to the License tag.
In mozjs31 asmjs was simpler, in the js/src/jit
directory, and under MPL 2.0 license. Now it is
under js/src/asmjs/AsmJS and with apache license.
Comment 3 Marek Skalický 2015-10-12 07:04:02 EDT
Thank you for the review Paulo!

> 
>   Looking at build log, most warnings appear ok, but this
> one might have issues:
> 
> In file included from
> /builddir/build/BUILD/mozjs-38.0.0/js/src/js/src/Unified_cpp_js_src2.cpp:65:
> 0:
> /builddir/build/BUILD/mozjs-38.0.0/js/src/irregexp/RegExpEngine.cpp: In
> member function 'virtual bool js::irregexp::TextNode::FillInBMInfo(int, int,
> js::irregexp::BoyerMooreLookahead*, bool)':
> /builddir/build/BUILD/mozjs-38.0.0/js/src/irregexp/RegExpEngine.cpp:4605:48:
> warning: array subscript is above array bounds [-Warray-bounds]
>                          bm->Set(offset, chars[j]);
> 
> looking at the code it appears to be a false positive, likely
> because g++ did not understand that it should always return
> a value that is in bounds. But I may be mistaken, please
> comment.

It looks good to me.
j is always in the array bounds.

> 
> ---8<---
> mozjs38.src:18: W: mixed-use-of-spaces-and-tabs (spaces: line 18, tab: line
> 1)
> 
> Looks like you added a missing build requires from mozjs31
> spec, but did not match spaces vs tabs :)

Fixed:-)

> 
> ---8<---
> In js.pc I see:
> Version: 38.3.0esrpre
> 
> Looks like there is some confusion. But this is minor,
> just a comment. Should be expected from a .rc0.
> 

I've changed it to 38.2.1.rc0

> ---8<---
> I believe is is not strictly an update do mozjs31, so you may
> modify the changelog to not say so. It should only have conflicts
> with mozjs31-devel and mozjs38-devel, otherwise, runtime will
> not conflict.

OK, you are right. Fixed.

> 
> ---8<---
> Please remove the bundled mozjs-38.0.0/modules/zlib/
> directory before starting build (mozjs31 does not have
> a modules subdir). It should not use it due to --with-system-zlib,
> but just to be sure.

OK.

> 
> ---8<---
> There are some new files under apache license, so, it should
> be required to add "ASL 2.0" to the License tag.
> In mozjs31 asmjs was simpler, in the js/src/jit
> directory, and under MPL 2.0 license. Now it is
> under js/src/asmjs/AsmJS and with apache license.


OK. Also added AFL - js/src/jit-test/tests/sunspider/check-string-unpack-code.js
Comment 5 Paulo Andrade 2015-10-12 14:00:56 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines
- Development (unversioned) .so files in -devel subpackage, if present.
  Note: Unversioned so-files directly in %_libdir.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL", "LGPL (v2.1 or later) (with incorrect FSF address)",
     "*No copyright* MPL (v2.0)", "LGPL (v2.1)", "*No copyright* MIT/X11
     (BSD like)", "*No copyright* LGPL (v2.1 or later)", "Public domain",
     "GPL (v3 or later)", "Apache (v2.0) BSD (3 clause) MIT/X11 (BSD
     like)", "zlib/libpng", "GPL (v2 or later) (with incorrect FSF
     address)", "BSD (2 clause)", "GPL (v3)", "Apache (v2.0)", "GPL (v2 or
     later)", "MIT/X11 (BSD like)", "*No copyright* Public domain", "BSD (3
     clause)", "LGPL (v2.1 or later)", "MPL (v2.0) BSD (3 clause)", "BSD (3
     clause) GPL (v2)", "Unknown or generated", "MPL (v2.0)", "GPL (v2)",
     "MPL (v1.1) GPL (unversioned/unknown version)". 11612 files have
     unknown license. Detailed output of licensecheck in
     /home/pcpa/1269539-mozjs38/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[-]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     mozjs38-debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: mozjs38-38.2.1-1.fc24.x86_64.rpm
          mozjs38-devel-38.2.1-1.fc24.x86_64.rpm
          mozjs38-debuginfo-38.2.1-1.fc24.x86_64.rpm
          mozjs38-38.2.1-1.fc24.src.rpm
mozjs38.x86_64: W: invalid-license LGPLv2.1
mozjs38.x86_64: W: invalid-license LGPLv2.1+
mozjs38-devel.x86_64: W: invalid-license LGPLv2.1
mozjs38-devel.x86_64: W: invalid-license LGPLv2.1+
mozjs38-devel.x86_64: W: only-non-binary-in-usr-lib
mozjs38-devel.x86_64: W: no-documentation
mozjs38-debuginfo.x86_64: W: invalid-license LGPLv2.1
mozjs38-debuginfo.x86_64: W: invalid-license LGPLv2.1+
mozjs38.src: W: invalid-license LGPLv2.1
mozjs38.src: W: invalid-license LGPLv2.1+
4 packages and 0 specfiles checked; 0 errors, 10 warnings.

Requires
--------
mozjs38-debuginfo (rpmlib, GLIBC filtered):

mozjs38 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.4)(64bit)
    libm.so.6()(64bit)
    libnspr4.so()(64bit)
    libplc4.so()(64bit)
    libplds4.so()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)

mozjs38-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    mozjs38(x86-64)
    pkgconfig(nspr)

Provides
--------
mozjs38-debuginfo:
    mozjs38-debuginfo
    mozjs38-debuginfo(x86-64)

mozjs38:
    libmozjs-38.so()(64bit)
    libmozjs-38.so(js)(64bit)
    mozjs38
    mozjs38(x86-64)

mozjs38-devel:
    mozjs38-devel
    mozjs38-devel(x86-64)
    pkgconfig(mozjs-38)

Unversioned so-files
--------------------
mozjs38: /usr/lib64/libmozjs-38.so

Source checksums
----------------
https://people.mozilla.org/~sstangl/mozjs-38.2.1.rc0.tar.bz2 :
  CHECKSUM(SHA256) this package     : 01994c758174bc173bcf4960f05ecb4da21014f09641a63b2952bbf9eeaa8b5c
  CHECKSUM(SHA256) upstream package : 01994c758174bc173bcf4960f05ecb4da21014f09641a63b2952bbf9eeaa8b5c

Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1269539
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 6 Paulo Andrade 2015-10-12 14:06:07 EDT
Package is approved!

Please bump release between reviews. Even when there is significant
rework in the package. For now, only before submitting it.

Please make and test the small changes below before importing it.

Please verify that parallel make still does not work.

%check pass all tests on x86_64. Change it back to only exit with
0 status on failure if it fails on other arch, preferably only on
secondary arches. I know it was copied from mozjs31, but I no
longer remember the details, I think it failed 2 or 3 tests on
other arches, or something like that.

Please add me as co-maintainer, as I believe I may need to use
it, and possibly add minor 0ad patches in the near future :)
Comment 7 Marek Skalický 2015-10-13 05:31:08 EDT
New Package SCM Request
=======================
Package Name: mozjs38
Short Description: JavaScript interpreter and libraries
Upstream URL: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey
Owners: mskalick pcpa
Branches: f23
InitialCC:
Comment 8 Upstream Release Monitoring 2015-10-13 05:45:44 EDT
mskalick's scratch build of mozjs38-38.2.1-1.fc20.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11425256
Comment 9 Marek Skalický 2015-10-13 05:57:33 EDT
Thank you for the review.

All errors fixed.

Spec URL: https://mskalick.fedorapeople.org/mozjs38/mozjs38.spec
SRPM URL: https://mskalick.fedorapeople.org/mozjs38/mozjs38-38.2.1-2.fc22.src.rpm
Comment 10 Upstream Release Monitoring 2015-10-13 06:20:34 EDT
mskalick's scratch build of mozjs38-38.2.1-2.fc20.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11425663
Comment 11 Gwyn Ciesla 2015-10-13 08:46:31 EDT
This SCM request method has been deprecated. Please see https://fedoraproject.org/wiki/PackageDB_admin_requests.
Comment 12 Kevin Fenzi 2015-10-19 08:49:51 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/mozjs38
Comment 13 Fedora Update System 2015-11-23 07:29:03 EST
mozjs38-38.2.1-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-cee2efa3a1
Comment 14 Fedora Update System 2015-11-23 15:12:12 EST
mozjs38-38.2.1-3.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-e400efbf68
Comment 15 Fedora Update System 2015-11-24 21:55:11 EST
mozjs38-38.2.1-3.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update mozjs38'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-e400efbf68
Comment 16 Fedora Update System 2015-11-25 07:05:46 EST
mozjs38-38.2.1-4.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-d4842a40f3
Comment 17 Fedora Update System 2015-11-25 21:53:55 EST
mozjs38-38.2.1-4.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update mozjs38'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-d4842a40f3
Comment 18 Fedora Update System 2015-11-26 08:57:02 EST
mozjs38-38.2.1-5.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-7c2272a08a
Comment 19 Fedora Update System 2015-11-26 18:49:32 EST
mozjs38-38.2.1-5.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update mozjs38'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-7c2272a08a
Comment 20 Fedora Update System 2015-12-05 20:23:16 EST
mozjs38-38.2.1-5.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.